<?php
if ($this->ADMIN_USER)
{
	// if the user is logged in and has admin rights lets check if the shop is fully configured
	$content.=mslib_fe::giveSiteConfigurationNotice();
}
$ms['page']=$get['tx_multishop_pi1']['page_section'];
switch ($ms['page'])
{
	case 'info':
		// cms information pages
		$output_array=array();
		if (is_numeric($get['tx_multishop_pi1']['id']))
		{
			include('front_pages/info.php');
		}
	break;
	case 'admin_invoices':
		if ($this->ADMIN_USER) include('admin_pages/admin_invoices.php');	
	break;	
	case 'admin_stores':
		if ($this->ADMIN_USER) include('admin_pages/admin_stores.php');	
	break;	
	case 'admin_product_feeds':
		if ($this->ADMIN_USER) include('admin_pages/admin_product_feeds.php');	
	break;
	case 'admin_product_attributes':
		if ($this->ADMIN_USER) include('admin_pages/admin_product_attributes.php');	
	break;
	case 'admin_customer_import':
		if ($this->ADMIN_USER) include('admin_pages/admin_customer_import.php');	
	break;
	case 'admin_system_update_catalog_languages':
		if ($this->ADMIN_USER) include('admin_pages/admin_system_update_catalog_languages.php');	
	break;		
	case 'admin_system_fix_catalog_default_language':
		if ($this->ADMIN_USER)
		{
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_categories_description', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_description', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_manufacturers_cms', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_manufacturers_info', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);			
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_options', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_options_values', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_options_values_extra', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_reviews_description', '',array('language_id'=>0));
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			$content.='Whole catalog is updated to the default language ID.';
		}
	break;
	case 'admin_customer_groups':
		if ($this->ADMIN_USER) include('admin_pages/admin_customer_groups.php');	
	break;
	case 'admin_system_delete_disabled_products':
		set_time_limit(86400); 
		ignore_user_abort(true);	
		$content.='<div class="main-heading"><h2>Deleting disabled products</h2></div>';		
		$str="SELECT products_id from tx_multishop_products where products_status=0";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
		{		
			$counter=0;
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				mslib_befe::deleteProduct($row['products_id']);		
				$counter++;
			}
			$content.='<strong>'.$counter.' products has been deleted.</strong>';
		}
	break;
	case 'admin_system_sort_full_catalog_on_alphabet':
		if ($this->ADMIN_USER)
		{	
			$str="SELECT c.categories_id from tx_multishop_categories c, tx_multishop_categories_description cd where c.status=1 and c.parent_id='0' and c.page_uid='".$this->showCatalogFromPage."' and c.categories_id=cd.categories_id order by cd.categories_name";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			$counter=0;
			$content.='<div class="main-heading"><h2>Sorting full catalog on alphabet</h2></div>';		
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$updateArray=array();
				$updateArray['sort_order']=$counter;
				$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_categories', 'categories_id='.$row['categories_id'],$updateArray);
				$res = $GLOBALS['TYPO3_DB']->sql_query($query);		
				$content.= $row['categories_id'].'<br />';		
				$counter++;
			}		
			$subcategories_array = array();
			mslib_fe::getSubcats($subcategories_array,0);
			if (count($subcategories_array))
			{
				foreach ($subcategories_array as $item)
				{
					// try to sort the subcats
					$content.= $item.'<br />';			
					$str="SELECT c.categories_id from tx_multishop_categories c, tx_multishop_categories_description cd where c.status=1 and c.parent_id='".$item."' and c.page_uid='".$this->showCatalogFromPage."' and c.categories_id=cd.categories_id order by cd.categories_name";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
					$counter=0;
					while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
					{
						$updateArray=array();
						$updateArray['sort_order']=$counter;
						$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_categories', 'categories_id='.$row['categories_id'],$updateArray);
						$res = $GLOBALS['TYPO3_DB']->sql_query($query);		
						$counter++;
					}	
					// try to find and sort the products
					$str="SELECT p2c.categories_id, p.products_id from tx_multishop_products p, tx_multishop_products_description pd, tx_multishop_products_to_categories p2c where p.products_status=1 and p.page_uid='".$this->showCatalogFromPage."' and p.products_id=pd.products_id and p.products_id=p2c.products_id and p2c.categories_id='".$item."' order by pd.products_name";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
					$counter=0;
					while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
					{
						$updateArray=array();
						$updateArray['sort_order']=$counter;
						$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products_to_categories', 'products_id='.$row['products_id'].' and categories_id='.$row['categories_id'],$updateArray);
						$res = $GLOBALS['TYPO3_DB']->sql_query($query);	
						$updateArray=array();
						$updateArray['sort_order']=$counter;
						$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products', 'products_id='.$row['products_id'],$updateArray);
						$res = $GLOBALS['TYPO3_DB']->sql_query($query);							
						$counter++;
					}							
				}
			}
		}
	break;
	case 'ultrasearch':
		include_once('front_pages/ultrasearch.php');
	break;	
	case 'checkout':
		if (strstr($ms['MODULES']['CHECKOUT_TYPE'],"..")) die('error in CHECKOUT_TYPE value');
		else 
		{
			if (strstr($ms['MODULES']['CHECKOUT_TYPE'],"/"))
			{
				// relative mode
				set_include_path($this->DOCUMENT_ROOT.$ms['MODULES']['CHECKOUT_TYPE']);
				require($this->DOCUMENT_ROOT.$ms['MODULES']['CHECKOUT_TYPE'].'/checkout.php');	
			}
			else
			{
				// relative mode
				set_include_path(t3lib_extMgm::extPath('multishop').PATH_SEPARATOR.t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/checkout/'.$ms['MODULES']['CHECKOUT_TYPE'].'/');
				require('checkout.php');	
			}
		}	
	break;
	case 'admin_customers':
		if ($this->ADMIN_USER) include('admin_pages/admin_customers.php');
	break;	
	case 'admin_price_update':
		// product updater, excel download/upload
		if ($this->ADMIN_USER) include('admin_pages/includes/price_update/admin_price_update.php');
	break;
	case 'admin_price_update_dl_xls':
		if ($this->ADMIN_USER)
		{
		   require_once(t3lib_extMgm::extPath('multishop').'res/PExcel/Writer.php');
		   include('admin_pages/includes/price_update/mass_price_update_xls_export.php');
		}
	break;
	case 'admin_price_update_up_xls':
	if ($this->ADMIN_USER)
	{
		if (isset($post['Submit']))
		{
			$dest =$this->DOCUMENT_ROOT.'uploads/tx_multishop/tmp/' . $_FILES['datafile']['name'];
			if (move_uploaded_file($_FILES['datafile']['tmp_name'], $dest))
			{
				$filename = $_FILES['datafile']['name'];
			}
			else
			{
				$filename = '';
			}
		}		
		if (!empty($filename))
		{
			require_once(t3lib_extMgm::extPath('multishop').'res/excellib/reader.php');
			include('admin_pages/includes/price_update/mass_price_update_xls_import.php');
		}
	}
	break;	
	case 'shopping_cart':
		if (strstr($ms['MODULES']['SHOPPING_CART_TYPE'],"..")) die('error in SHOPPING_CART_TYPE value');
		else 
		{
			if (strstr($ms['MODULES']['SHOPPING_CART_TYPE'],"/"))
			{
				// relative mode
				set_include_path($this->DOCUMENT_ROOT.$ms['MODULES']['SHOPPING_CART_TYPE']);
				require($this->DOCUMENT_ROOT.$ms['MODULES']['SHOPPING_CART_TYPE'].'.php');	
			}
			else
			{
				include('front_pages/includes/shopping_cart/default.php');	
			}
		}				
	break;		
	case 'products_detail':
		include('front_pages/products_detail.php');	
	break;
	case 'products_search':
		include('front_pages/products_search.php');	
	break;	
	case 'be_products_search':
		include('front_pages/includes/be_products_search.php');	
	break;	
	case 'products_listing':
		include('front_pages/products_listing.php');
	break;
	case 'manufacturers_products_listing':
		include('front_pages/manufacturers_products_listing.php');	
	break;
	case 'manufacturers':
		include('front_pages/manufacturers.php');	
	break;			
	case 'order_received_thank_you_page':
		include('front_pages/order_received_thank_you_page.php');	
	break;
	case 'admin_sitemap_creator':
		if ($this->ADMIN_USER) include('admin_pages/admin_sitemap_creator.php');			
	break;
	case 'admin_system_clear_database':
		if ($this->ROOTADMIN_USER) include('admin_pages/admin_system_clear_database.php');	
	break;
	case 'admin_system_consistency_checker':
		if ($this->ADMIN_USER) include('admin_pages/admin_system_consistency_checker.php');	
	break;
	case 'admin_system_images_update':
		if ($this->ADMIN_USER) include('admin_pages/admin_system_images_update.php');	
	break;
	case 'admin_system_clear_multishop_cache':
		if ($this->ADMIN_USER) include('admin_pages/admin_system_clear_multishop_cache.php');	
	break;
	case 'admin_system_clear_cooluri_cache':
		if ($this->ADMIN_USER) include('admin_pages/admin_system_clear_cooluri_cache.php');	
	break;
	case 'admin_system_rebuild_flat_database':
		if ($this->ADMIN_USER) include('admin_pages/admin_system_rebuild_flat_database.php');	
	break;
	case 'admin_system_orphan_files':
		if ($this->ADMIN_USER) include('admin_pages/admin_system_orphan_files.php');	
	break;
	case 'admin_ajax':
//		if ($this->ADMIN_USER) include('admin_pages/admin_ajax.php');	
	break;	
	case 'admin_mass_product_updater':
		if ($this->ADMIN_USER) include('admin_pages/admin_mass_product_updater.php');	
	break;	
	case 'admin_modules':
		if ($this->ADMIN_USER) include('admin_pages/admin_modules.php');	
	break;
	case 'admin_orders_stats_tax':
		if ($this->ADMIN_USER) include('admin_pages/admin_orders_stats_tax.php');
    break;
	case 'admin_orders_stats':
		if ($this->ADMIN_USER) include('admin_pages/admin_orders_stats.php');
    break;
	case 'admin_orders':
		if ($this->ADMIN_USER) include('admin_pages/admin_orders.php');
    break;
	case 'admin_new_order':
		if ($this->ADMIN_USER) include('admin_pages/includes/manual_order/admin_new_order.php');
    break;	
	case 'admin_add_order':
		if ($this->ADMIN_USER) include('admin_pages/admin_add_order.php');	
	break;
	case 'admin_list_manual_orders':
		if ($this->ADMIN_USER) include('admin_pages/includes/manual_order/admin_list_manual_orders.php');	
	break;
	case 'admin_proced_manual_order':
		if ($this->ADMIN_USER) include('admin_pages/includes/manual_order/admin_proced_manual_order.php');	
	break;
	case 'admin_shipping_modules':
		if ($this->ADMIN_USER) include('admin_pages/admin_shipping_modules.php');	
	break;				
	case 'admin_shipping_costs':
		if ($this->ADMIN_USER) include('admin_pages/admin_shipping_costs.php');	
	break;							
	case 'admin_payment_modules':
		if ($this->ADMIN_USER) include('admin_pages/admin_payment_modules.php');	
	break;				
	case 'admin_shipping_payment_mappings':
		if ($this->ADMIN_USER) include('admin_pages/admin_shipping_payment_mappings.php');	
	break;				
	case 'admin_shipping_countries':
		if ($this->ADMIN_USER) include('admin_pages/admin_shipping_countries.php');	
	break;		
	case 'admin_shipping_zones':
		if ($this->ADMIN_USER) include('admin_pages/admin_shipping_zones.php');	
	break;		
	case 'admin_shipping_options':
		if ($this->ADMIN_USER) include('admin_pages/admin_shipping_options.php');	
	break;
	case 'admin_manufacturers':
		if ($this->ADMIN_USER) include('admin_pages/includes/admin_manufacturers.php');
	break;
	case 'admin_coupons':
		if ($this->ADMIN_USER) include('admin_pages/admin_coupons.php');	
	break;
	case 'admin_orders_status':
		if ($this->ADMIN_USER) include('admin_pages/admin_orders_status.php');	
	break;
	case 'admin_add_order':
		if ($this->ADMIN_USER) include('admin_pages/admin_add_order.php');	
	break;
	case 'admin_cms':
		if ($this->ADMIN_USER) include('admin_pages/includes/admin_cms.php');
	break;
	case 'admin_import':
		if (!$ms['MODULES']['ADMIN_IMPORT_TYPE']) $script='admin_pages/includes/admin_import.php';
		if (strstr($ms['MODULES']['ADMIN_IMPORT_TYPE'],"..")) die('error in ADMIN_IMPORT_TYPE value');
		else 
		{
			if (strstr($ms['MODULES']['ADMIN_IMPORT_TYPE'],"/"))
			{
				// relative mode
				$script=$this->DOCUMENT_ROOT.$ms['MODULES']['ADMIN_IMPORT_TYPE'].'.php';
			}
			else
			{
				$script='admin_pages/includes/admin_import.php';
			}
		}		
		if ($get['action']=='run_job' and $get['code'])
		{
			$get['job_id']='';
			$str="SELECT id FROM `tx_multishop_import_jobs` where code='".addslashes($get['code'])."'";					
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{	
				$get['job_id']=$row['id'];
			}
			if (is_numeric($get['job_id'])) include($script);
		}
		else
		{
			if ($this->ADMIN_USER) include($script);
		}
	break;
	// psp thank you or error pages
	case 'psp_accepturl_mollie':
		if ($get['transaction_id'])
		{
			$orders_id=mslib_fe::getOrdersIdByTransactionId($get['transaction_id'],'mollie');
			if ($orders_id)
			{
				$order=mslib_fe::getOrder($orders_id);
				if ($order['payed'])
				{
					header('Location: '.t3lib_div::locationHeaderUrl($this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl')));
				}
				else
				{
					// payment status is not yet received. we try to retrieve the report url one more time
					$qry = $GLOBALS['TYPO3_DB']->sql_query("select orders_id, psp, code from tx_multishop_payment_transactions where transaction_id = '".addslashes($get['transaction_id'])."'");
					$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);			
					set_include_path(t3lib_extMgm::extPath('multishop').PATH_SEPARATOR.t3lib_extMgm::extPath('multishop').'scripts/front_pages/');
					// get template
					$user_payment_methods=mslib_fe::loadPaymentMethods();
					foreach ($user_payment_methods as $user_method)
					{				
						if ($user_method['code'] == $row['code'])
						{
							// we have found the user payment method. now process it against our template
							// $payment_methods=mslib_fe::loadAllPaymentMethods();
							// $psp=$payment_methods[$user_payment_methods['provider']];										
							if ($user_method['vars'] and $user_method['provider'])
							{
								$vars=unserialize($user_method['vars']);
							}			
						}
					}
					if ($vars['partner_id'] and $orders_id)
					{
						require_once('includes/psp_forms/classes/mollie.php');			
						$iDEAL = new iDEAL_Payment($vars['partner_id']);
						$iDEAL->checkPayment($get['transaction_id']);
						if ($iDEAL->getPaidStatus() == true)
						{
							// payment succeed. lets update the order				
							mslib_fe::updateOrderStatusToPayed($orders_id);
							header('Location: '.t3lib_div::locationHeaderUrl($this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl')));
						}
						else
						{
							header('Location: '.t3lib_div::locationHeaderUrl($this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_exceptionurl')));						
						}
					}	
					// else end
				}
			}
		}	
	break;
	case 'psp_accepturl_ideal_ing_advanced':
		$trx_id			= $get['trxid'];
		$entrance_code	= $get['ec'];
		if ($trx_id)
		{
			$qry = $GLOBALS['TYPO3_DB']->sql_query("select orders_id, psp, code from tx_multishop_payment_transactions where transaction_id = '".$trx_id."'");
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
			if ($row['orders_id'])
			{
				// get template
				$user_payment_methods=mslib_fe::loadPaymentMethods();
				foreach ($user_payment_methods as $user_method)
				{				
					if ($user_method['code'] == $row['code'])
					{
						// we have found the user payment method. now process it against our template
						// $payment_methods=mslib_fe::loadAllPaymentMethods();
						// $psp=$payment_methods[$user_payment_methods['provider']];						
						if ($user_method['vars'] and $user_method['provider'])
						{
							$vars=unserialize($user_method['vars']);
						}			
					}
				}			
				if ($vars['test']=='true') 			$ms['url']	='ssl://idealtest.secure-ing.com:443/ideal/iDeal';
				else 								$ms['url']	='ssl://ideal.secure-ing.com:443/ideal/iDeal';				
				// iDEAL Advanced Configuration
				$ideal_adv_config['PRIVATEKEY']			= 'priv.pem';
				//enter your password below
				$ideal_adv_config['PRIVATEKEYPASS'] 	= $vars['private_key_pass'];
				$ideal_adv_config['PRIVATECERT']		= 'cert.cer';
				$ideal_adv_config['CERTIFICATE0']		= 'webserver.cer';
				$ideal_adv_config['ACQUIRERURL']		= $ms['url'];
				$ideal_adv_config['ACQUIRERTIMEOUT']	= 60;
				//enter your merchant id below
				$ideal_adv_config['MERCHANTID']			= $vars['merchant_id'];
				$ideal_adv_config['SUBID']				= $vars['merchant_subid'];
				//enter payment confirmation url
				$ideal_adv_config['MERCHANTRETURNURL']	= $this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl_ideal_ing_advanced');
				$ideal_adv_config['EXPIRATIONPERIOD']	= 'PT60M';
				//enter the path to the logfile below
				//$ideal_adv_config['LOGFILE']			= '';
				//$ideal_adv_config['TraceLevel']			= 'DEBUG,ERROR';
				
				require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_ing_advanced/iDEALConnector.php');
				$iDEALConnector = new iDEALConnector($ideal_adv_config);
				// Behandeling van het status request
				$transactionID = $trx_id;			
				// Opsturen van het request. De MPI layer zorgt voor alle
				// validatie. Indien een validatie niet is gelukt is de 
				// response altijd een "ErrorResponse" object.
				$response = $iDEALConnector->RequestTransactionStatus( $transactionID );
				if ($response->IsResponseError())
				{
					// Een fout is opgetreden.
					$errorCode = $response->getErrorCode();
					$errorMsg = $response->getErrorMessage();
					$consumerMessage = $response->getConsumerMessage();
				}
				else 
				{
					// Geldige response. 
					$acquirerID = $response->getAcquirerID();
					$consumerName = $response->getConsumerName();
					$consumerAccountNumber = $response->getConsumerAccountNumber();
					$consumerCity = $response->getConsumerCity();
					$transactionID = $response->getTransactionID();
					// De status is een integer en kan middels een aantal 
					// constanten geinitialiseerd zijn: 
					// IDEAL_TX_STATUS_INVALID		Status code van iDEAL server niet herkend
					// IDEAL_TX_STATUS_SUCCESS		Transactie succcess
					// IDEAL_TX_STATUS_CANCELLED	Transactie geannuleerd door bezoeker
					// IDEAL_TX_STATUS_EXPIRED		Transactie verlopen
					// IDEAL_TX_STATUS_FAILURE		Transactie fout
					// IDEAL_TX_STATUS_OPEN  		Transactie staat nog open
					$status = $response->getStatus();
				}
				if ( $status === IDEAL_TX_STATUS_SUCCESS ) 
				{
					mslib_fe::updateOrderStatusToPayed($row["orders_id"]);
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl'));
				}
				if ( $status === IDEAL_TX_STATUS_CANCELLED ) 
				{
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_cancelurl'));
				}
				if ( $status === IDEAL_TX_STATUS_EXPIRED ) 
				{
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_exceptionurl'));
				}
				if ( $status === IDEAL_TX_STATUS_FAILURE ) 
				{
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_exceptionurl'));
				}
				if ( $status === IDEAL_TX_STATUS_OPEN ) 
				{
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl'));
				}
			}
		}		
		$content.=$this->pi_getLL('your_payment_has_not_been_completed');
	break;
	case 'psp_accepturl_ideal_rabobank_professional':
		$trx_id			= $get['trxid'];
		$entrance_code	= $get['ec'];
		if (is_numeric($trx_id))
		{
			$qry = $GLOBALS['TYPO3_DB']->sql_query("select orders_id, psp from tx_multishop_payment_transactions where transaction_id = '".$trx_id."'");
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
			if ($row['orders_id'])
			{
				// get template
				$user_payment_methods=mslib_fe::loadPaymentMethods();
				foreach ($user_payment_methods as $user_method)
				{				
					if ($user_method['code'] == $row['psp'])
					{
						// we have found the user payment method. now process it against our template
						// $payment_methods=mslib_fe::loadAllPaymentMethods();
						// $psp=$payment_methods[$user_payment_methods['provider']];						
						if ($user_method['vars'] and $user_method['provider'])
						{
							$vars=unserialize($user_method['vars']);
						}			
					}
				}
				if ($vars['test']=='true') 			$ms['url']	='ssl://idealtest.rabobank.nl:443/ideal/iDeal';
				else 								$ms['url']	='ssl://ideal.rabobank.nl:443/ideal/iDeal';
				# config file for iDEAL PHP thinMPI 
				#Your Private Key file
				$ideal_adv_config['Privatekey']			= 'priv.pem';
				#Your Password for the Private Key
				$ideal_adv_config['PrivatekeyPass']		= $vars['private_key_pass'];
				#Your own certificate (to create fingerprint)
				$ideal_adv_config['Privatecert']		= 'cert.cer';
				
				#Put all trusted certificates of your acquirer here
				#increase the number behind Certificate by one starting with 0. 
				#There are up to 9 certificates allowed here all of them in the 
				#security-subdirectory
				$ideal_adv_config['Certificate0']		= 'ideal.cer';
				
				#IP address and path of the server that gets the request
				#This value contains the URL of the Rabo iDEAL acquirer
				#For test and integration this value should be: ssl://idealtest.rabobank.nl:443/ideal/iDeal
				#For production you must change this value to: ssl://ideal.rabobank.nl:443/ideal/iDeal
				$ideal_adv_config['AcquirerURL']		= $ms['url'];
				$ideal_adv_config['AcquirerTimeout']	= '60';
				
				# The ID of the merchant. This ID will be given during the sign-in-process at the acquirer
				$ideal_adv_config['MerchantID']			= $vars['merchant_id'];
				# The SubID of the merchant. Normally this ID is 0. It will be given during the sign-in-process at the acquirer
				$ideal_adv_config['SubID']				= $vars['merchant_subid'];
				# The desired cryptography. Currently only SHA1_RSA is supported
				$ideal_adv_config['AuthenticationType']	= 'SHA1_RSA';
				
				# The URL the merchant should be redirected to after the payment.
				$ideal_adv_config['MerchantReturnURL']	= $this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl_ideal_rabobank_professional');
				# The currency of the bill
				$ideal_adv_config['Currency']			= 'EUR';
				# The expiration period of the payment
				$ideal_adv_config['ExpirationPeriod']	= 'PT30M';
				# The language of the issuer screen, currently only nl is supported
				$ideal_adv_config['Language']			= 'nl';
				# the default description for the payment
				$ideal_adv_config['DESCRIPTION']		= substr($ms['MODULES']['STORE_NAME'], 0, 15);
				# The default EntranceCode
				$ideal_adv_config['EntranceCode']		= '12345678';
				
				//include needed files
				require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_rabobank_professional/ThinMPI.php');
				require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_rabobank_professional/AcquirerStatusRequest.php');
				
				//Create StatusRequest
				$data = new AcquirerStatusRequest();
				
				//Set parameters
				//$data -> setMerchantID( $merchantID );
				//$data -> setSubID( "0" );
				//$data -> setAuthentication( $authentication );
				$transID = $get['trxid'];
				$transID = str_pad($transID, 16, "0");
				$data -> setTransactionID( $transID  );
				
				//Create ThinMPI instance and process request
				$rule = new ThinMPI($ideal_adv_config);
				$result = $rule->ProcessRequest( $data );
				
				if(!$result->isOK())
				{
					//StatusRequest failed, let the consumer click to try again
					//print("Status kon niet worden opgehaald, klik <a href=\"\" onclick=\"refresh()\">hier</a> om het nogmaals te proberen<br>");
					//print("Foutmelding van iDEAL: ");
					$Msg = $result->getErrorMessage();
					//print("$Msg<br>");
				}
				else if(!$result->isAuthenticated())
				{
					//Transaction failed, inform the consumer
					//print("Uw bestelling is helaas niet betaald, probeer het nog eens");
				}
				else
				{
					$status = $result->getStatus();
				
					if ( $status === IDEAL_TX_STATUS_SUCCESS ) 
					{
						mslib_fe::updateOrderStatusToPayed($row["orders_id"]);
						header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl&order_id='.$row["orders_id"]));
					}
					if ( $status === IDEAL_TX_STATUS_CANCELLED ) 
					{
						header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_cancelurl'));
					}
					if ( $status === IDEAL_TX_STATUS_EXPIRED ) 
					{
						header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_exceptionurl'));
					}
					if ( $status === IDEAL_TX_STATUS_FAILURE ) 
					{
						header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_exceptionurl'));
					}
					if ( $status === IDEAL_TX_STATUS_OPEN ) 
					{
						header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_cancelurl'));
					}
				}
			}
		}
		$content.=$this->pi_getLL('your_payment_has_not_been_completed');
	break;
	case 'adyen_pay':
		if ($get['authResult'])
		{
			switch($get['authResult'])
			{
				case 'AUTHORISED':
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl'));	
				break;
				case 'REFUSED':
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_exceptionurl'));	
				break;
				case 'CANCELLED':
					header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_cancelurl'));	
				break;
			}
		}
//		header('Location: '.$this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl&mr='.$get['merchantReference']));
	break;		
	case 'psp_accepturl':
	case 'psp_declineurl':
	case 'psp_exceptionurl':
	case 'psp_cancelurl':
		$page=mslib_fe::getCMScontent($ms['page'],$GLOBALS['TSFE']->sys_language_uid);
		if ($page[0]['name'])	$header_label=$page[0]['name'];
		else					$header_label='Payment';
		$content.='<div class="main-heading"><h2>'.$header_label.'</h2></div>';
		if ($page[0]['content'])
		{
			$content.=$page[0]['content'];
		}	
		else
		{
			// show standard thank you
			if ($ms['page']=='psp_accepturl') 		$content.=$this->pi_getLL('your_payment_has_been_completed');
			else									$content.=$this->pi_getLL('your_payment_has_not_been_completed');
		}
	break;
	// psp thank you or error pages eof
	case 'custom_page':
	// custom page hook that can be controlled by third-party plugin
		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/pi1/classes/class.mslib_fe.php']['customPage']))
		{
			$params = array (
				'status' => $status,
				'table' => $table,
				'id' => $id,
				'this' => &$this,
				'content' => &$content
			); 
			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/pi1/classes/class.mslib_fe.php']['customPage'] as $funcRef)
			{
				t3lib_div::callUserFunction($funcRef, $params, $this);
			}
		}	
	// custom page hook that can be controlled by third-party plugin eof
	break;
	default:
		$ms['page']='home';
		// load cms top
		$content.=mslib_fe::printCMScontent('home_top',$GLOBALS['TSFE']->sys_language_uid);
		// load cms top eof	
		if ($ms['MODULES']['HOME_PRODUCTS_LISTING'])
		{
			include('front_pages/products_listing.php');	
		}
		// load cms bottom
		$content.=mslib_fe::printCMScontent('home_bottom',$GLOBALS['TSFE']->sys_language_uid);
		// load cms bottom eof	
	break;	
}	
if ($ms['MODULES']['SHOW_INNER_FOOTER_NAV'])
{
	$content.='
	<div id="tx_multishop_footer_menu">
	<ul>
		<li><a href="'.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=manufacturers').'">'.ucfirst($this->pi_getLL('manufacturers')).'</a></li>
		<li><a href="'.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=shopping_cart').'">'.ucfirst($this->pi_getLL('basket')).'</a></li>
		<li><a href="'.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=checkout').'">'.ucfirst($this->pi_getLL('go_to_checkout')).'</a></li>
	</ul>
	</div>
	';	
}
if (!$ms['MODULES']['DISABLE_CRUMBAR'] and $GLOBALS['TYPO3_CONF_VARS']["tx_multishop"]['crumbar_html']) $content=$GLOBALS['TYPO3_CONF_VARS']["tx_multishop"]['crumbar_html'].$content;
if ($this->ADMIN_USER)
{
	// old admin menu here
}			
// ajax module (alpha!!!)
if (!$this->ajax_content and $this->conf['ajax_module'])
{
	$GLOBALS['TSFE']->additionalHeaderData[] = '
	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'js/jquery.history.js"></script> 
	<script>
		function pageload(hash)
		{
			if(hash)
			{
				// restore ajax loaded state						
				jQuery("div#content").load(hash);
				scrollTo(0,0); 
			}
		}			
		jQuery(document).ready(function($)
		{
			$.history.init(pageload);
			var clicked=0;
			$(\'body\').delegate(\'.ajax_link\', \'click\', function(e)
			{
				e.preventDefault();
				jQuery("div#content").html(\'<div class="boxed-content"><img src="'.t3lib_extMgm::siteRelPath($this->extKey).'templates/images/loading2.gif" height="16" width="16" /> loading...</div>\');
				var location = $(this).attr(\'href\');
				$("div#leftsection").load(location+\'?&type='.$this->conf['ajax_pagetype_id_left_column'].'\');
					var hash = location+\'?&type='.$this->conf['ajax_pagetype_id_normal_column'].'\';							
					$.history.load(hash);
					hash = hash.replace(/^.*#/, \'\');
			});
		});				
	</script>
	';
}			
// ajax module eof
$content='<div id="tx_multishop_pi1_core">'.$content.'</div>';
?>